-- gotta go faster --

-- Custom dashmode script made by Bluetorch --

local function ResetVars(player) -- Resets vars
	player.normalspeed = skins[player.mo.skin].normalspeed
	player.fakenormalspeed = skins[player.mo.skin].normalspeed
	player.jumpfactor = FRACUNIT
end

local TOPSPEED = 100*FRACUNIT -- Cap speed for dashmode.
local HAVETOPSPEED = true
local RUNTIME = 20*FRACUNIT -- How long do you have to run for to activate dashmode.
local DEFNORMALSPEED = 48*FRACUNIT -- Put your default normal speed here.
local MAXJUMPHIGHT = 3/2*FRACUNIT -- Maximum jump power when in dashmode.
local SKIN = "cosmetal" -- Your character's skin name goes here.

local function DoNormalSpeed(player) -- Raises Top Speed
	if player.fakenormalspeed == nil then player.fakenormalspeed = DEFNORMALSPEED return end
	local cms = player.cms
	if not cms then return end
	if not cms.dashmode then return end
	
	if player.fakenormalspeed < TOPSPEED and cms.dashmode.activated and player.isxmomentum and P_IsObjectOnGround(player.mo)
		player.fakenormalspeed = $1 + 2*FRACUNIT/5  
	end
	if player.normalspeed < TOPSPEED and cms.dashmode.activated and not player.isxmomentum and P_IsObjectOnGround(player.mo)
		player.normalspeed = $1 + 2*FRACUNIT/5 
	end
	if player.jumpfactor < MAXJUMPHIGHT and cms.dashmode.activated
		player.jumpfactor = $1 + FRACUNIT/100
	end
end

addHook("PlayerThink", function(player)
	if player.mo.skin == SKIN and player.mo.sprite2 != SPR2_JSKI then
		local cms = player.cms
		if not player.cms.hyper
			DoNormalSpeed(player) -- Does everything for normal speed.

			if (player.speed > 27*FRACUNIT or player.pflags&PF_STARTDASH) and not (leveltime % 5) -- Checks if you are running.
				cms.dashmode.counter = $ + FRACUNIT
			end
			if player.speed < 25*FRACUNIT and P_IsObjectOnGround(player.mo) and not (player.pflags&PF_STARTDASH) or P_PlayerInPain(player) -- Disables dashmode
				if cms.dashmode.activated then
					S_StartSound(player.mo, sfx_kc65) -- Exiting dashmode soundeffect.
					cms.dashmode.activated = false
					cms.dashmode.counter = 0
					ResetVars(player)
				end
			end
		end
		if cms.dashmode.activated or player.cms.hyper
			
			if (player.panim == PA_RUN and player.speed >= player.runspeed) or player.secondjump
				player.mo.state = S_PLAY_DASH
			end
			player.charflags = $1|SF_RUNONWATER -- Enables Running on water.
		else
			if player.panim == PA_DASH and not cms.jetboost.active
				player.mo.state = S_PLAY_RUN
			end
			player.charflags = $1 & ~SF_RUNONWATER
		end
	end
end)

addHook("PlayerThink", function(player) -- Default Dashmode Activation
	if player.mo.skin == SKIN and player.mo.sprite2 != SPR2_JSKI then
		local cms = player.cms
		if cms.dashmode.counter >= RUNTIME
			if not cms.dashmode.activated
				if cms.hyper
					P_NukeEnemies(player.mo, player.mo, 1536*FRACUNIT)
					if (player == displayplayer)
						P_StartQuake(50*FRACUNIT, TICRATE/2)
					end
				elseif cms.super or (player.solchar and player.solchar.transformed)
					P_NukeEnemies(player.mo, player.mo, 768*FRACUNIT)
					if (player == displayplayer)
						P_StartQuake(25*FRACUNIT, TICRATE/2)
					end
				else
					P_StartQuake(12*FRACUNIT, TICRATE/2)
				end
				cms.dashmode.activated = true
				S_StartSound(player.mo, sfx_kc4d) -- Entering dashmode soundeffect
				if not player.xmomentum
					if player.speed >= player.normalspeed
						player.normalspeed = player.speed
					end
				else
					if player.speed >= player.fakenormalspeed
						player.fakenormalspeed = player.speed
					end
				end
			end
			if CMS.Check("genfx")
				P_GenesisGhost(player.mo, 4)
			else
				local g = P_SpawnGhostMobj(player.mo)
				g.fuse = 2
			end
		end
	end
end)

addHook("PlayerCanDamage", function(p)
	if not(p.mo and p.mo.valid and p.mo.skin == SKIN) then return end
	if p.cms.dashmode.activated
		return true
	end
end)

addHook("MobjMoveCollide", function(mo, spike) -- Spike breaking adapted from code by ARJr.
    if mo.valid
    and (mo.type == MT_PLAYER)
	and (mo.player.cms.dashmode.activated or mo.player.cms.hyper)
    and (spike.type == MT_SPIKE or spike.type == MT_WALLSPIKE)
	and L_ZCollide(mo, spike)
		P_KillMobj(spike,mo,mo)
    end
end)

//No Damage when dashmode adapted from code by SMS Alfredo
addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if target.player and not (damagetype&DMG_DEATHMASK)
	and (target.player.cms and target.player.cms.dashmode.activated)
		return true
	end
end, MT_PLAYER)

//Player Height thing
addHook("PlayerHeight", function(p)
	if not(p.cms) then return end
	if p.cms.dashmode.activated and P_IsObjectOnGround(p.mo)
		return skins[p.mo.skin].spinheight
	elseif P_IsObjectOnGround(p.mo) and not(p.pflags&PF_SPINNING)
		return skins[p.mo.skin].height
	end
end)

addHook("PlayerCanEnterSpinGaps", function(p)
	if not(p.cms) then return end
	if p.cms.dashmode.activated
		return true
	elseif P_IsObjectOnGround(p.mo) and not(p.pflags&PF_SPINNING)
		return false
	end
end)