-- HUD --
customhud.SetupFont("DIGI_", 1)

local switchY = 157
hud.add(function(v, player)
	if not(player.mo and player.mo.valid) then return end
	
	local cms = player.cms
	if not cms then return end
	if player.mo.skin == "cosmetal" and not(skins[player.skin].name == "clonefighter")
		hud.disable("lives")
		local x,y
		//Cooldown bars
		if CMS.Check("liveshud")
			local hudcolor
			if not cms.super
				hudcolor = SKINCOLOR_SILVER
			else
				hudcolor = SKINCOLOR_YELLOW
			end
			switchY = 157
			x,y = 3, 166
			local cooldown = cms.jetboost.cooldown
			local cooldown2 = cms.metalflap.cooldown
			//Bars
			local bar2Y = y + 7
			local barpatch = v.cachePatch("BAR")
			v.drawStretched(x*FRACUNIT, y*FRACUNIT, 44*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, SKINCOLOR_CARBON))
			v.drawStretched(x*FRACUNIT, bar2Y*FRACUNIT, 70*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, SKINCOLOR_CARBON))
			if cooldown
				v.drawStretched(x*FRACUNIT, y*FRACUNIT, (cooldown/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, CMS.Variables["barcolor"].value))
			end
			if cooldown2
				v.drawStretched(x*FRACUNIT, bar2Y*FRACUNIT, (cooldown2/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, CMS.Variables["barcolor"].value))
			end
			v.drawString(x+5,y,"Jet Boost",V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_BLUEMAP|V_ALLOWLOWERCASE,"small-thin")
			v.drawString(x+5,y+7,"Metal Flap",V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_BLUEMAP|V_ALLOWLOWERCASE,"small-thin")
			
			v.draw(13, 193, v.getSprite2Patch("cosmetal", SPR2_LIFE, player.cmsSuper,A,0),V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT,v.getColormap("sonic", player.powers[pw_super] and player.mo.color or player.skincolor))
			v.draw(0,156,v.cachePatch("CMSLIVES"), V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, v.getColormap(0, hudcolor))
			
			if player.lives != INFLIVES
				customhud.CustomFontString(v, 31,188, tostring(player.lives), "DIGI_", V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
			else
				customhud.CustomFontChar(v, 43,192, 36, "DIGI_", V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
			end
		else	
			hud.enable("lives")
			//Bars
			x,y = hudinfo[HUD_LIVES].x,hudinfo[HUD_LIVES].y-9
			local cooldown = cms.jetboost.cooldown
			local cooldown2 = cms.metalflap.cooldown
			//Define color vars for bars
			local color = CMS.Variables["barcolor"].value
			local color2 = SKINCOLOR_SUPERBLACKHOLE5
			local barpatch = v.cachePatch("BAR")
			switchY = 155
			
			if cooldown > 0
				v.drawStretched((x+1)*FRACUNIT, (y+1)*FRACUNIT, (cooldown/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, color2))
				v.drawStretched(x*FRACUNIT, y*FRACUNIT, (cooldown/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, color))
			end
			if cooldown2 > 0
				v.drawStretched((x+1)*FRACUNIT, (y-7)*FRACUNIT, (cooldown2/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, color2))
				v.drawStretched(x*FRACUNIT, (y-8)*FRACUNIT, (cooldown2/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, color))
			end
		end
		
		//Custom1 Ability Switch HUD
		if cms.jumpabil == 1
			v.drawString(x, switchY, "Jump Ability: Metal Flap", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_ALLOWLOWERCASE|V_BLUEMAP,"small-thin")
		else
			v.drawString(x, switchY, "Jump Ability: Hover", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_ALLOWLOWERCASE|V_BLUEMAP,"small-thin")
		end
		
		local soundplaying, caption = CMS.MetalSoundPlaying(player.mo)
		if soundplaying and subtitles
			v.drawString(85, 185, "\132Cosmetal\128: "..caption, V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS|V_ALLOWLOWERCASE)
		end
	elseif player.mo.skin == "cosmetal" and skins[player.skin].name == "clonefighter"
		hud.enable("lives")
		local x = hudinfo[HUD_LIVES].x
		local switchY = 152
		//Custom1 Ability Switch HUD
		if cms.jumpabil == 1
			v.drawString(x, switchY, "Jump Ability: Metal Flap", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_ALLOWLOWERCASE|V_BLUEMAP,"thin")
		else
			v.drawString(x, switchY, "Jump Ability: Hover", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_ALLOWLOWERCASE|V_BLUEMAP,"thin")
		end
		
		local cooldown = cms.jetboost.cooldown
		local cooldown2 = cms.metalflap.cooldown
		//Define color vars for bars
		local color = CMS.Variables["barcolor"].value
		local color2 = SKINCOLOR_SUPERBLACKHOLE5
		local barpatch = v.cachePatch("BAR")
		switchY = 155
		
		if cooldown > 0
			v.drawStretched((x+1)*FRACUNIT, (y+1)*FRACUNIT, (cooldown/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, color2))
			v.drawStretched(x*FRACUNIT, y*FRACUNIT, (cooldown/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, color))
		end
		if cooldown2 > 0
			v.drawStretched((x+1)*FRACUNIT, (y-7)*FRACUNIT, (cooldown2/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, color2))
			v.drawStretched(x*FRACUNIT, (y-8)*FRACUNIT, (cooldown2/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, color))
		end
	else
		hud.enable("lives")
	end
end, "game")

local function emeraldsHud(v, player)
	if not(player.mo and player.mo.valid and player.mo.skin == "cosmetal") then return end
	if CMS.Check("emeraldshud")
		if not G_RingSlingerGametype()
			CMS.drawEmeralds(v)
			if not(player.solchar and player.solemeralds)
				v.draw(291,10,v.cachePatch("CMSEMERALDS1"), V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTORIGHT)
			else
				v.draw(291,10,v.cachePatch("CMSEMERALDS2"), V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTORIGHT)
			end
			v.drawString(298, 5, "Emeralds", V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS|V_GREENMAP|V_ALLOWLOWERCASE, "thin-right")
		else
			CMS.drawRSEmeralds(v, player.powers[pw_emeralds])
			v.draw(160, 0, v.cachePatch("CMSEMERALDS3"), V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP)
		end
	end
end
customhud.SetupItem("emeralds", "cms", emeraldsHud, "game")