local function ResetVars(player) -- Resets vars
	player.normalspeed = skins[player.mo.skin].normalspeed
	player.fakenormalspeed = skins[player.mo.skin].normalspeed
	player.jumpfactor = FRACUNIT
end

addHook("PlayerSpawn", function(player)
	if not (player.mo and player.mo.valid) or player.mo.skin != "cosmetal" then return end
	if player.cms == nil
		player.cms = {
			dj = false,
			winsound = false,
			waitTimer = 0,
			jumpabil = $ == nil and 1 or $,
			bombdive = {
				active = false,
				done = false
			},
			dashmode = {
				counter = 0,
				activated = false
			},
			dashsound = false,
			jetboost = {
				active = false,
				timer = 0,
				cooldown = 0
			},
			metalflap = {
				active = false,
				timer = 0,
				cooldown = 0,
				charging = false,
				chargetimer = 0,
				chargetype = "none"
			},
			super = false,
			hyper = false,
			dead = false,
			idle = false,
			bt = {
				tossflag = 0,
				custom1 = 0,
				custom2 = 0,
				custom3 = 0,
				fire = 0
			},
			taunt = {
				cando = true,
				timer = 0
			}
		}
	end
	local cms = player.cms
	cms.dj = false
	cms.winsound = false
	cms.waitTimer = 0
	cms.imagecount = 0
	cms.bombdive = {
		active = false,
		done = false
	}
	cms.idle = false
	player.mo.rollangle = 0
	ResetVars(player)
end)

addHook("ShouldJingleContinue", function(player, musname)
	if player and player.mo and player.mo.skin == "cosmetal" and player.cms.dj and not (player.cms.super or (player.solchar and playersolchar.istransformed) or(player.darkform and player.darkform.on))
		return true
	else
		return false
	end
end)

addHook("MobjMoveBlocked", function(mo, thing, line)
	--Rocket Boost Bonk
	if not (mo.player and mo.skin == "cosmetal") then return end
	local player = mo.player
	local cms = player.cms
	if cms.jetboost.active and (line and line.valid) and not thing
		cms.jetboost.active = false
		cms.jetboost.timer = 0
		player.secondjump = 0
		if player.powers[pw_shield]&SH_NOSTACK == SH_ARMAGEDDON
			P_BlackOw(player)
			P_RemoveShield(player)
		end
		local shake = FRACUNIT*32
		if not(player.powers[pw_shield]&SH_FORCE or player.cms.super or (player.solchar and player.solchar.istransformed) or(player.darkform and player.darkform.on))
			if(player == displayplayer)
				P_StartQuake(shake, TICRATE/3)
			end
			S_StartSound(mo, sfx_pstop)
			P_SetObjectMomZ(mo, 8*FRACUNIT)
			P_InstaThrust(mo, player.drawangle-ANGLE_180, 18*FRACUNIT)
			player.pflags = $ & ~PF_JUMPED
			cms.jetboost.canceled = true
			mo.state = S_PLAY_PAIN
		else
			P_InstaThrust(mo, player.drawangle-ANGLE_180, 32*FRACUNIT)
			if player.powers[pw_shield]&SH_FORCE
				P_SetObjectMomZ(mo, 16*FRACUNIT)
				S_StartSound(mo, sfx_ngskid)
				player.pflags = $|PF_SHIELDABILITY
			elseif player.cms.super or (player.solchar and player.solchar.istransformed) or(player.darkform and player.darkform.on)
				if player.cms.hyper
					P_SetObjectMomZ(mo, 32*FRACUNIT)
					P_NukeEnemies(mo, mo, 1536*FRACUNIT)
					if (player == displayplayer)
						P_StartQuake(50*FRACUNIT, 10)
					end
				else
					P_SetObjectMomZ(mo, 24*FRACUNIT)
				end
				S_StartSound(mo, sfx_zoom)
			end
			mo.state = S_PLAY_SPRING
			player.pflags = $|PF_JUMPED
			cms.jetboost.cooldown = 0
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if not (player.mo and player.mo.valid and player.mo.skin == "cosmetal") then continue end
		local mo = player.mo
		
		if player.cms == nil
			player.cms = {
				dj = false,
				winsound = false,
				waitTimer = 0,
				jumpabil = $ == nil and 1 or $,
				imagecount = 0,
				bombdive = {
					active = false,
					done = false
				},
				dashmode = {
					counter = 0,
					activated = false
				},
				dashsound = false,
				jetboost = {
					active = false,
					timer = 0,
					cooldown = 0
				},
				metalflap = {
					active = false,
					timer = 0,
					cooldown = 0,
					charging = false,
					chargetimer = 0,
					chargetype = "none"
				},
				super = false,
				hyper = false,
				dead = false,
				idle = false,
				menu = {},
				bt = {
					tossflag = 0,
					custom1 = 0,
					custom2 = 0,
					custom3 = 0,
					fire = 0
				},
				taunt = {
					cando = true,
					timer = 0
				}
			}
		end
		local cms = player.cms
		local bt = cms.bt
		
		bt.tossflag = ((player.cmd.buttons&BT_TOSSFLAG) and $+1) or ($ > 0 and -1) or 0
		bt.custom1 = ((player.cmd.buttons&BT_CUSTOM1) and $+1) or ($ > 0 and -1) or 0
		bt.custom2 = ((player.cmd.buttons&BT_CUSTOM2) and $+1) or ($ > 0 and -1) or 0
		bt.custom3 = ((player.cmd.buttons&BT_CUSTOM3) and $+1) or ($ > 0 and -1) or 0
		bt.fire = ((player.cmd.buttons&BT_ATTACK) and $+1) or ($ > 0 and -1) or 0
		
		CMS.HoverThinker(player)

		if player.powers[pw_super]
			cms.super = true
		else
			cms.super = false
			cms.hyper = false
		end

		if cms.super
			if not(player.superaura and player.superaura.valid)
				local aura = P_SpawnMobjFromMobj(mo, 0,0,0, MT_CMS_SUPERAURA)
				aura.target = mo
				player.superaura = aura
			end
			if (player.hyper and player.hyper.capable and not (player.mo.state >= S_PLAY_HYPERTRNS_1 and player.mo.state < S_PLAY_HYPERTRNS_6))
				player.hyper.capable = false
				cms.hyper = true
			end
			if not(cms.hyper)
				if CMS.Check("supercolor") == 1
					mo.color = (SKINCOLOR_SUPERCOBALT1 + abs( ( (leveltime >> 1) % 9) - 4))
				elseif CMS.Check("supercolor") == 2
					mo.color = (SKINCOLOR_SUPERCRIMSON1 + abs( ( (leveltime >> 1) % 9) - 4))
				elseif CMS.Check("supercolor") == 3
					mo.color = (SKINCOLOR_SUPERGREEN1 + abs( ( (leveltime >> 1) % 9) - 4))
				elseif CMS.Check("supercolor") == 4
					mo.color = (SKINCOLOR_SUPERBLACKHOLE1 + abs( ( (leveltime >> 1) % 9) - 4))
				end
			else
				mo.color = SKINCOLOR_CMSHYPER
				if player.speed > FRACUNIT
					if CMS.Check("genfx")
						local aa = P_GenesisGhost(mo, 4)
						aa.colorized = true
						aa.color = mo.color
					else
						local aa = P_SpawnMobj(mo.x - mo.momx, mo.y - mo.momy, mo.z - mo.momz, MT_GHOST)
						aa.angle = mo.angle
						aa.skin = mo.skin
						aa.color = mo.color
						aa.state = mo.state
						aa.frame = $|FF_TRANS50
						aa.fuse = 4
						aa.colorized = true
					end
				end
			end
		else
			if (player.superaura and player.superaura.valid)
				P_RemoveMobj(player.superaura)
			end
			cms.hyper = false
		end
		
		if leveltime % 3 == 0 and player.playerstate != PST_DEAD and CMS.Check("sparkles")
			local star = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-5,5)*FRACUNIT, P_RandomRange(-5,5)*FRACUNIT, player.mo.height/2+P_RandomRange(-5,5)*FRACUNIT, MT_BOXSPARKLE)
			star.momx = P_RandomRange(-2, 2) * FRACUNIT
			star.momy = P_RandomRange(-2, 2) * FRACUNIT
			star.momz =  P_RandomRange(-2, 2) * FRACUNIT
			star.source = player.mo
		end
		
		if cms.super or (player.solchar and player.solchar.istransformed) or(player.darkform and player.darkform.on)
			if(player.panim == PA_WALK or player.panim == PA_RUN or player.panim == PA_DASH)
				player.mo.spriteyoffset = FRACUNIT*2 + (3 * cos(ANG10*leveltime))
			elseif player.idle
				player.mo.spriteyoffset = min((FRACUNIT*(cms.waitTimer)), FRACUNIT*15 + (6 * cos(ANG10*cms.waitTimer)))
			else
				player.mo.spriteyoffset = 0
			end
		else
			player.mo.spriteyoffset = 0
		end
		if player.powers[pw_carry] & CR_NIGHTSMODE then return end
		
		player.hassupermusic = true
		
		if player.playerstate == PST_DEAD --Custom death animation
			cms.jetboost.active = false
			cms.jetboost.timer = 0
			cms.metalflap.active = false
			cms.metalflap.timer = 0
			cms.dashmode.active = false
			cms.dashmode.counter = 0

			mo.flags = $ & ~MF_NOCLIPHEIGHT

			if P_IsObjectOnGround(mo)
				mo.state = S_CMS_FLOORDEAD
				if CMS.Check("memes")
					mo.sprite2 = SPR2_CNTE
				end
				if cms.dead
					mo.momx = 0
					mo.momy = 0
					mo.rollangle = 0
				end
			else
				mo.state = S_PLAY_DEAD
				if CMS.Check("memes")
					mo.sprite2 = SPR2_EROR
				end
				mo.rollangle = $ + ANG10
			end

			if not cms.dead
				P_InstaThrust(mo, player.drawangle, player.prevspeed/2)
				mo.momz = 2*$/3
				cms.dead = true
			end
		elseif cms.dead
			player.charflags = $|SF_MACHINE
			cms.dead = false
		end
		player.prevspeed = FixedHypot(mo.momx, mo.momy)
		
		if player.pflags&PF_STARTDASH
			player.camerascale = skins[mo.skin].camerascale/2
		else
			player.camerascale = skins[mo.skin].camerascale
		end
		
		cms.idle = mo.state == S_PLAY_WAIT or mo.state == S_CMS_SWITCHOFF or mo.state == S_CMS_OFF
		
		if not cms.idle
			player.waitTimer = 0
		else
			player.waitTimer = $+1
			if player.waitTimer == TICRATE*8
				mo.state = S_CMS_SWITCHOFF
			end
			if player.speed > 0
				mo.state = S_PLAY_STND
				player.idle = false
			end
			player.panim = PA_IDLE
		end
		
		if (CMS.Check("switchbutton") and bt.custom2 == 1) or (not CMS.Check("switchbutton") and bt.custom1 == 1)
			if cms.jumpabil == 1
				cms.jumpabil = 0
			else
				cms.jumpabil = 1
			end
			S_StartSoundAtVolume(nil, sfx_kc5e, 128, player)
		end

		cms.dj = $ or false
		if bt.tossflag == 1 and not PSO
			if P_IsObjectOnGround(mo)
				if bt.custom3 <= 1
					cms.dj = not $
					if cms.dj == true
						P_PlayJingleMusic(player, CMS.tunes[CMS.Check("metaltunes")], nil, true, JT_OTHER)
						player.pflags = $|PF_FULLSTASIS
					else
						if mo.state == S_CMS_METALDJ
							mo.state = S_PLAY_STND
						end
						P_RestoreMusic(player)
						player.pflags = $ & ~PF_FULLSTASIS
					end
				elseif cms.taunt.cando
					cms.taunt.timer = TICRATE*2
					cms.taunt.cando = false
				end
			end
		end
		
		if cms.dj
			player.pflags = $|PF_FULLSTASIS
			if mo.state != S_CMS_METALDJ
				mo.state = S_CMS_METALDJ
			end
		end
		
		if bt.custom3 == 1 and bt.fire > 1
			if cms.super
				cms.super = false
				player.powers[pw_super] = 0
				P_SpawnShieldOrb(player)
				mo.color = player.skincolor
				P_RestoreMusic(player)
				mo.state = $
				player.charflags = $ & ~SF_SUPER
			elseif (player.solchar and player.solchar.istransformed)
				player.solchar.istransformed = 0
				mo.color = player.skincolor
				P_RestoreMusic(player)
				player.solchar.musicplaying = 0
				mo.eflags = $ & ~ MFE_FORCESUPER
				mo.state = $
			end
		end
		
		if cms.dashmode.activated == true
			if player.isxmomentum
				player.spcanflip = false
			end
			if player.pflags&PF_JUMPED and not(player.pflags&PF_THOKKED)
				local momz = mo.momz*P_MobjFlip(mo)
				if momz > 0
					mo.state = S_PLAY_SPRING
				else
					mo.state = S_PLAY_FALL
				end
			end
		else
			cms.imagecount = 0
		end
		
		if not cms.metalflap.charging
		and not ((player.pflags&PF_STARTDASH) and mo.state == S_PLAY_METALAIM)
			if cms.dashmode.activated or cms.hyper
				A_BossScream(mo, 0, MT_WATERZAP)
			end
		end
		
		if cms.dashmode.activated
			if (((leveltime-3)/2) & 1) and not cms.super and not(player.solchar and player.solchar.istransformed) and not(player.darkform and player.darkform.on)
				if not cms.metalflap.charging
					if CMS.Check("flashcolor")
						mo.colorized = true
						mo.color = CMS.Check("flashcolor")
					end
				else
					mo.colorized = true
					mo.color = SKINCOLOR_ORANGE
				end
			else
				if not cms.super and not (player.solchar and player.solchar.istransformed) and not (player.darkform and player.darkform.on)
					mo.color = player.skincolor
				end
				mo.colorized = false
			end
		else
			if not cms.super and not (player.solchar and player.solchar.istransformed) and not(player.darkform and player.darkform.on)
				mo.color = player.skincolor
			end
			mo.colorized = false
		end
		
		--Metal Flap stuff
		if P_IsObjectOnGround(mo)
			cms.metalflap.cooldown = 0
			cms.metalflap.boosts = 0
		end
		if cms.metalflap.cooldown
			cms.metalflap.cooldown = $-1
		end
		if cms.metalflap.timer
			mo.state = S_PLAY_SPRING
			cms.metalflap.timer = $-1
		end
		if cms.metalflap.active
			if player.powers[pw_shield]&SH_NOSTACK == SH_THUNDERCOIN
				A_BossScream(mo, 0, MT_WATERZAP)
			end
		end
		if cms.metalflap.timer == 4 and cms.metalflap.active
			local visualcue = P_SpawnGhostMobj(mo)
			visualcue.scale = mo.scale*3/2
			visualcue.destscale = mo.scale*2
			visualcue.scalespeed = FRACUNIT/20
		end
		if cms.metalflap.timer == 0 and cms.metalflap.active
			if (not CMS.Check("abilswitch") and player.cmd.buttons&BT_SPIN) or (CMS.Check("abilswitch") and player.cmd.buttons&BT_JUMP)
				if player.powers[pw_shield]&SH_NOSTACK != SH_ARMAGEDDON
					CMS.StartCharge(player, "boost")
				else
					CMS.StartCharge(player, "armageddon")
				end
			elseif (not CMS.Check("abilswitch") and player.cmd.buttons&BT_JUMP) or (CMS.Check("abilswitch") and player.cmd.buttons&BT_SPIN)
				CMS.StartCharge(player, "blast")
			end
			cms.metalflap.active = false
		end
		
		--Charge Code
		if cms.metalflap.charging and not P_IsObjectOnGround(mo)
			P_InstaThrust(mo, mo.angle, 0)
			player.secondjump = 0
			if(player.cmd.buttons&BT_SPIN or player.cmd.buttons&BT_JUMP)
			and cms.metalflap.chargetimer < TICRATE*3
				if (not CMS.Check("abilswitch") and player.cmd.buttons&BT_JUMP) or (CMS.Check("abilswitch") and player.cmd.buttons&BT_SPIN)
					cms.metalflap.chargetype = "blast"
				elseif (not CMS.Check("abilswitch") and player.cmd.buttons&BT_SPIN) or (CMS.Check("abilswitch") and player.cmd.buttons&BT_JUMP)
					cms.metalflap.chargetype = "boost"
				end
				if cms.metalflap.chargetype == "blast"
					if not player.a
						player.a = P_SpawnMobj(mo.x,mo.y,mo.z,MT_ENERGYAURA)
						if player.a and player.a.valid then 
							player.a.target = mo
							player.a.scale = mo.scale
							player.a.spriteyoffset = -16*FRACUNIT
						end
					end
					if cms.metalflap.chargetimer == TICRATE*3/2
						local visualcue = P_SpawnGhostMobj(mo)
						visualcue.scale = mo.scale*3/2
						visualcue.destscale = mo.scale*2
						visualcue.scalespeed = FRACUNIT/20
						S_StartSound(mo, sfx_s3kb3)
					end
					if cms.metalflap.chargetimer == TICRATE*5/2
						local visualcue = P_SpawnGhostMobj(mo)
						visualcue.scale = mo.scale*3/2
						visualcue.destscale = mo.scale*2
						visualcue.scalespeed = FRACUNIT/20
						S_StartSound(mo, sfx_s3kb31)
					end
					player.t = P_LookForEnemies(player, false, true)
					if player.t
						mo.angle = R_PointToAngle2(mo.x, mo.y, player.t.x, player.t.y)
						player.drawangle = mo.angle
						P_SpawnLockOn(player, player.t, S_LOCKON3)
					end
				end
				mo.state = S_PLAY_METALAIM
				cms.metalflap.chargetimer = $+1
				if not cms.super or not(player.solchar and player.solchar.istransformed) or not(player.darkform and player.darkform.on)
					player.charge_speed = min($+FRACUNIT, FRACUNIT*170)
				else
					player.charge_speed = min($+FRACUNIT*2, FRACUNIT*340)
				end
				local gather = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_ENERGYGATHER)
				if gather and gather.valid then
					gather.target = mo
					gather.fuse = 35
					gather.extravalue1 = P_RandomRange(0,359)*ANG1
					gather.extravalue2 = P_RandomRange(0,359)*ANG1
					gather.scale = mo.scale/4
				end
				if cms.metalflap.chargetimer == 2*TICRATE
				and (cms.metalflap.chargetype == "boost" or cms.metalflap.chargetype == "armageddon")
					local visualcue = P_SpawnGhostMobj(mo)
					visualcue.scale = mo.scale*3/2
					visualcue.destscale = mo.scale*2
					visualcue.scalespeed = FRACUNIT/20
				end
			else
		//The outcome of the charge
				if cms.metalflap.chargetype == "boost" // Rocket Boost
					S_StopSoundByID(mo, sfx_bechrg)
					CMS.StartRocketBoost(player, player.charge_speed, false, sfx_s3k54, false)
				elseif cms.metalflap.chargetype == "armageddon" // Rocket Boost w/ Armageddon Shield
					S_StopSoundByID(mo, sfx_s3k53)
					CMS.StartRocketBoost(player, player.charge_speed, false, sfx_s3k54, false)
				elseif cms.metalflap.chargetype == "blast" // Laser Blast
					S_StopSoundByID(mo, sfx_bechrg)
					S_StartSound(mo, sfx_s3k54)
					mo.state = S_PLAY_SPRING
					P_InstaThrust(mo, player.drawangle+ANGLE_180, 8*FRACUNIT)
					local blast
					local blast2
					local blast3
					local blast4
					local blast5
					if player.t
						blast = P_SpawnPointMissile(mo, player.t.x, player.t.y, player.t.z, MT_ENERGYBLAST, mo.x, mo.y, mo.z)
					else
						blast = CMS.SpawnMissile(mo, MT_ENERGYBLAST)
					end
					blast.source = mo
					if cms.metalflap.chargetimer >= TICRATE*3/2
						blast.scale = FRACUNIT*5/4
						blast2 = CMS.SpawnMissile(mo, MT_ENERGYBLAST, player.drawangle-(ANGLE_22h/2))
						if (blast2 and blast2.valid)
							blast2.scale = FRACUNIT*3/4
						end
						blast3 = CMS.SpawnMissile(mo, MT_ENERGYBLAST, player.drawangle+(ANGLE_22h/2))
						if (blast3 and blast3.valid)
							blast3.scale = FRACUNIT*3/4
						end
					end
					
					if cms.metalflap.chargetimer >= TICRATE*5/2
						blast.scale = FRACUNIT*2
						blast4 = CMS.SpawnMissile(mo, MT_ENERGYBLAST, player.drawangle-ANGLE_22h)
						blast4.scale = FRACUNIT/2
						blast5 = CMS.SpawnMissile(mo, MT_ENERGYBLAST, player.drawangle+ANGLE_22h)
						blast5.scale = FRACUNIT/2
					end
		//Missile Handling
					if blast and blast.valid then
						if not player.t
							P_InstaThrust(blast, blast.angle, 32*blast.scale)
						end
						if G_GametypeHasTeams() then
							blast.colorized = true
							blast.color = mo.color
						end
						if (player.b != nil and player.b.valid) and (player.c != nil and player.c.valid)
							P_InstaThrust(player.b, player.b.angle, 32*player.b.scale)
							P_InstaThrust(player.c, player.c.angle, 32*player.c.scale)
							if G_GametypeHasTeams()
								player.b.colorized = true
								player.c.colorized = true
								player.b.color = mo.color
								player.c.color = mo.color
							end
						end
					end
				end
				cms.metalflap.charging = false
			end
			if cms.metalflap.chargetimer == 3*TICRATE
				if cms.metalflap.chargetype == "boost"
					S_StopSoundByID(mo, sfx_bechrg)
					CMS.StartRocketBoost(player, player.charge_speed, false, sfx_s3k54, false)
					cms.metalflap.charging = false
				elseif cms.metalflap.chargetype == "blast"
					S_StopSoundByID(mo, sfx_bechrg)
					S_StartSound(mo, sfx_s3k54)
					mo.state = S_PLAY_SPRING
					P_InstaThrust(mo, player.drawangle+ANGLE_180, 8*FRACUNIT)
					local blast
					local blast2
					local blast3
					local blast4
					local blast5
					if player.t
						blast = P_SpawnPointMissile(mo, player.t.x, player.t.y, player.t.z, MT_ENERGYBLAST, mo.x, mo.y, mo.z)
					else
						blast = CMS.SpawnMissile(mo, MT_ENERGYBLAST)
					end
					blast.scale = FRACUNIT*2
					blast2 = CMS.SpawnMissile(mo, MT_ENERGYBLAST, player.drawangle-ANGLE_22h)
					blast2.scale = FRACUNIT/2
					blast3 = CMS.SpawnMissile(mo, MT_ENERGYBLAST, player.drawangle+ANGLE_22h)
					blast3.scale = FRACUNIT/2
					blast4 = CMS.SpawnMissile(mo, MT_ENERGYBLAST, player.drawangle-(ANGLE_22h/2))
					blast4.scale = FRACUNIT*3/4
					blast5 = CMS.SpawnMissile(mo, MT_ENERGYBLAST, player.drawangle+(ANGLE_22h/2))
					blast5.scale = FRACUNIT*3/4
					if blast and blast.valid then
						if not player.t
							P_InstaThrust(blast, blast.angle, 32*blast.scale)
						end
						if G_GametypeHasTeams() then
							blast.colorized = true
							blast.color = mo.color
						end
						if (player.b != nil and player.b.valid) and (player.c != nil and player.c.valid)
							P_InstaThrust(player.b, player.b.angle, 32*player.b.scale)
							P_InstaThrust(player.c, player.c.angle, 32*player.c.scale)
							if G_GametypeHasTeams()
								player.b.colorized = true
								player.c.colorized = true
								player.b.color = mo.color
								player.c.color = mo.color
							end
						end
					end
				end
				cms.metalflap.charging = false
			end
			if not S_SoundPlaying(mo, sfx_s3k54) and cms.metalflap.chargetype == "armageddon"
				P_BlackOw(player)
				P_RemoveShield(player)
				CMS.StartRocketBoost(player, 120*FRACUNIT, false, sfx_s3k54, false)
			end
			P_SetObjectMomZ(mo, -FRACUNIT/2)
			mo.spriteyoffset = (4 * cos(ANG10*leveltime))
		elseif cms.metalflap.charging
			cms.metalflap.charging = false
			S_StopSoundByID(mo, sfx_bechrg)
			S_StopSoundByID(mo, sfx_s3k53)
		end
		if P_IsObjectOnGround(mo)
			cms.metalflap.chargetimer = 0
			player.sound_done = false
			player.store_speed = 0
			cms.metalflap.chargetype = "none"
		end
		
		if not ((player.cmd.buttons & BT_JUMP)
		and (player.pflags & PF_JUMPED))
			player.charflags = $|SF_NOSHIELDABILITY
			if not player.powers[pw_super]
				player.charflags = $ & ~SF_SUPER
			end
		else
			player.charflags = $|SF_SUPER
			player.charflags = $&~SF_NOSHIELDABILITY
		end
		
	--	 Rocket Boost Stuff --
		if cms.jetboost.setmomz == nil or P_IsObjectOnGround(mo)
		or mo.eflags&MFE_SPRUNG
			cms.jetboost.setmomz = false
		end
		if mo.eflags&MFE_SPRUNG
			if cms.jetboost.active
				mo.momx = $*5/4
				mo.momy = $*5/4
				mo.momz = $*5/4
				S_StartSound(mo, sfx_sprong)
			end
			cms.bombdive.done = false
			cms.jetboost.cooldown = 0
			cms.metalflap.cooldown = 0
			cms.jetboost.active = false
			player.rboost_timer = 0
		end

		if cms.jetboost.cooldown == nil or P_IsObjectOnGround(mo)
			cms.jetboost.cooldown = 0
		end
		if cms.jetboost.cooldown > 0
			cms.jetboost.cooldown = $-1
		end
		if cms.jetboost.canceled == nil
			cms.jetboost.canceled = false
		end
		if cms.jetboost.canceled 
		and (P_IsObjectOnGround(mo) or mo.eflags&MFE_SPRUNG)
			cms.jetboost.canceled = false
			player.viewrollangle = 0
			mo.rollangle = 0
			player.drawangle = player.startangle
		end
		if cms.jetboost.canceled
			mo.rollangle = $+ANGLE_22h
			player.drawangle = $+ANGLE_22h
			player.powers[pw_nocontrol] = 1
			cms.dashmode.counter = 0
			cms.dashmode.activated = false
		end
		if cms.jetboost.timer
			cms.jetboost.timer = max($-1,0)
		end
		if cms.jetboost.active
			if (cms.super or player.solchar and player.solchar.istransformed or player.darkform and player.darkform.on) and cms.jetboost.timer % 2 == 0 and cms.jetboost.timer > 0
				CMS.LaunchEffect(player, FRACUNIT*3/2, 1)
			elseif cms.jetboost.timer % 4 == 0 and cms.jetboost.timer > 0
				CMS.LaunchEffect(player, FRACUNIT, 1)
			end
			if cms.jetboost.setmomz
				if player.powers[pw_shield]&SH_NOSTACK == SH_WHIRLWIND
				or (player.powers[pw_shield]&SH_NOSTACK == SH_THUNDERCOIN)
					if (player.powers[pw_shield]&SH_NOSTACK == SH_THUNDERCOIN)
						A_BossScream(mo, 0, MT_WATERZAP)
					end
					P_SetObjectMomZ(mo, FRACUNIT*24)
				elseif (player.powers[pw_shield]&SH_NOSTACK == SH_ELEMENTAL)
				or (player.powers[pw_shield]&SH_NOSTACK == SH_BUBBLEWRAP)
					P_SetObjectMomZ(mo, -FRACUNIT*24)
				else
					P_SetObjectMomZ(mo, 0)
				end
			end
			if (player.powers[pw_shield]&SH_NOSTACK == SH_FLAMEAURA)
			or player.powers[pw_shield]&SH_NOSTACK == SH_ELEMENTAL
				P_InstaThrust(mo, player.drawangle, player.start_speed+40*FRACUNIT)
			else
				P_InstaThrust(mo, player.drawangle, player.start_speed)
			end
			mo.state = S_PLAY_DASH
			if CMS.Check("genfx")
				P_GenesisGhost(player.followmobj, 4)
			else
				local jetghost = P_SpawnGhostMobj(player.followmobj)
				jetghost.fuse = 4
			end
		end
		
		if cms.jetboost.timer == 0 and cms.jetboost.active
		or P_IsObjectOnGround(mo) and cms.jetboost.active
			if not P_IsObjectOnGround(mo) and not player.secondjump
			and not cms.jetboost.canceled
			and cms.jetboost.setmomz
				mo.state = S_PLAY_FALL
			end
			if player.powers[pw_shield]&SH_FORCE and player.powers[pw_shield]&SH_FORCEHP
			and not P_IsObjectOnGround(mo)
				P_InstaThrust(mo, player.drawangle, player.speed/2)
				S_StartSound(mo, sfx_ngskid)
				player.pflags = $|PF_SHIELDABILITY
			elseif player.powers[pw_shield]&SH_NOSTACK == SH_ARMAGEDDON
			and not P_IsObjectOnGround(mo)
				P_BlackOw(player)
				P_RemoveShield(player)
			end
			cms.jetboost.active = false
		end
		
		-- Bomb Dive, adding this bc funny or something idk --
		if (player.cmd.buttons&BT_SPIN) and player.secondjump
			cms.bombdive.active = true
			mo.state = S_PLAY_ROLL
			P_SetObjectMomZ(mo, FRACUNIT*14)
			S_StartSound(mo, sfx_zoom)
			cms.dashmode.counter = 0
			player.secondjump = 0
		end
		
		if (cms.bombdive and cms.bombdive.active)
			player.secondjump = 0
			cms.jetboost.timer = 0
			cms.metalflap.timer = 0
			if mo.momz*P_MobjFlip(mo) > 0
				mo.state = S_PLAY_SPRING
			else
				if abs(mo.momz*P_MobjFlip(mo)) > 15*FRACUNIT
					local g = P_SpawnGhostMobj(mo)
					g.fuse = TICRATE/2
					g.blendmode = AST_ADD
					g.color = ColorOpposite(player.skincolor)
				end
				mo.state = S_PLAY_ROLL
				mo.momx = $*8/10
				mo.momy = $*8/10
			end
			P_SetObjectMomZ(mo, -FRACUNIT*2, true)
			player.pflags = $|PF_JUMPED|PF_THOKKED
		end
		
		if P_IsObjectOnGround(mo)
			if (cms.bombdive and cms.bombdive.active)
				S_StartSound(mo, sfx_s3k54)
				P_SetObjectMomZ(mo, FRACUNIT*8)
				if not cms.super
					for i = 1, 4 do
						local laser = P_SpawnMobjFromMobj(mo, 0,0,mo.height/2, MT_ENERGYBLAST)
						laser.target = mo
						laser.scale = FRACUNIT/2
						laser.destscale = 0
						laser.scalespeed = FRACUNIT/160
						laser.angle = player.drawangle+(ANGLE_90*i)
						laser.fuse = TICRATE
						P_InstaThrust(laser, laser.angle, FRACUNIT*20)
					end
				else
					if not cms.hyper
						for i = 1, 8 do
							local laser = P_SpawnMobjFromMobj(mo, 0,0,mo.height/2, MT_ENERGYBLAST)
							laser.target = mo
							laser.scale = FRACUNIT/2
							laser.destscale = 0
							laser.scalespeed = FRACUNIT/160
							laser.angle = player.drawangle+(ANGLE_45*i)
							laser.fuse = TICRATE
							P_InstaThrust(laser, laser.angle, FRACUNIT*20)
						end
					else
						for i = 1, 16 do
							local laser = P_SpawnMobjFromMobj(mo, 0,0,mo.height/2, MT_ENERGYBLAST)
							laser.target = mo
							laser.scale = FRACUNIT/2
							laser.destscale = 0
							laser.scalespeed = FRACUNIT/160
							laser.angle = player.drawangle+(ANGLE_22h*i)
							laser.fuse = TICRATE
							P_InstaThrust(laser, laser.angle, FRACUNIT*20)
						end
					end
				end
				cms.bombdive.active = false
				cms.bombdive.done = true
			else
				cms.bombdive.active = false
				cms.bombdive.done = false
			end
		end
		
		if cms.bombdive.done
			mo.state = S_PLAY_ROLL
			player.secondjump = 0
		end
		
		mo.prevz = mo.z
	end
end)

addHook("JumpSpinSpecial",function(player)
	--Rocket Boost
	if not (player.mo and player.mo.valid and player.mo.skin == "cosmetal") then return end
	local cms = player.cms
	if (cms.bombdive.done or cms.bombdive.active) then return end
	if not(player.pflags&PF_USEDOWN)
	and cms.jetboost.cooldown == 0
	and not cms.metalflap.active
	and not cms.metalflap.charging
	and (not(player.cmd.buttons&BT_JUMP and player.rings > 49 and All7Emeralds(emeralds)) or cms.super)
		if player.powers[pw_shield]&SH_NOSTACK == SH_PITY then S_StartSound(player.mo, sfx_pity) end

		if cms.hyper and cms.super
			CMS.StartRocketBoost(player, player.speed+170*FRACUNIT, true, sfx_kc40, true, true)
		elseif cms.super or (player.solchar and player.solchar.istransformed) or(player.darkform and player.darkform.on)
			CMS.StartRocketBoost(player, player.speed+85*FRACUNIT, true, sfx_kc40, true, true)
		else
			CMS.StartRocketBoost(player, player.speed+50*FRACUNIT, true, sfx_kc40, true, true)
		end
		CMS.LaunchEffect(player, FRACUNIT, 1)
		return true
	end
end)

addHook("AbilitySpecial", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "cosmetal") then return end
	local cms = player.cms
	if (cms.bombdive.done or cms.bombdive.active) then return true end
	if cms.jumpabil == 1
		local water = 1+(player.mo.eflags&MFE_UNDERWATER)/MFE_UNDERWATER
		if cms.metalflap.cooldown == 0
		and not cms.jetboost.active
		and not cms.metalflap.charging
			if cms.metalflap.boosts == 0
				P_InstaThrust(player.mo, player.drawangle, player.speed)
				player.store_speed = max(player.speed, 20*FRACUNIT)
				player.force = 10*FRACUNIT
				P_SetObjectMomZ(player.mo, player.force/water)
				S_StartSound(player.mo, sfx_beflap)
				player.pflags = $ & ~PF_SPINNING
				cms.metalflap.timer = TICRATE*3/4
				cms.metalflap.active = true
				cms.metalflap.cooldown = TICRATE/4
				cms.metalflap.boosts = 1
				player.mo.state = S_PLAY_SPRING
				CMS.LaunchEffect(player, FRACUNIT)
			else
				P_InstaThrust(player.mo, player.drawangle, player.speed)
				player.store_speed = max(player.speed, 20*FRACUNIT)
				if cms.hyper and cms.super
					player.force = 32*FRACUNIT
				elseif cms.super or (player.solchar and player.solchar.istransformed) or(player.darkform and player.darkform.on)
					player.force = 24*FRACUNIT
				else
					player.force = 16*FRACUNIT
				end
				P_SetObjectMomZ(player.mo, (player.force+player.speed/16)/water)
				S_StartSound(player.mo, sfx_beflap)
				player.pflags = $ & ~PF_SPINNING
				cms.metalflap.timer = TICRATE*3/4
				cms.metalflap.active = true
				if cms.super or(player.solchar and player.solchar.istransformed)
					if cms.hyper and cms.super
						cms.metalflap.cooldown = TICRATE*2
					else
						cms.metalflap.cooldown = TICRATE*4
					end
				else
					cms.metalflap.cooldown = TICRATE*8
				end
				player.mo.state = S_PLAY_SPRING
				CMS.LaunchEffect(player, FRACUNIT*2)
			end
		end
		if cms.jumpabil == 1
			return true
		end
	end
end)